/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2009 Alpha Project Co., Ltd.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *  JSP-1.4.2 ʹߤѹ줿ߥϥɥؤб
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#if defined(SUPPORT_ETHER)

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ʹ */

/*
 * ed_dis_inter -- ߤػߤ롣
 */

IPM
ed_dis_inter(void)
{
	IPM	ipm = 0;
	UB mask;

	mask = sil_reb_mem((VP)MS104_INTMASK2);
	sil_wrb_mem((VP)MS104_INTMASK2, mask & ~MS104_INTMASK2_INT8);
//	syscall(get_ipm(&ipm));
//	syscall(chg_ipm(if_ed_handler_intmask));

	return ipm;
}

/*
 * ed_dis_inter -- ߤͭˤ롣
 */

void
ed_ena_inter(IPM ipm)
{
	UB mask;

	mask = sil_reb_mem((VP)MS104_INTMASK2);
	sil_wrb_mem((VP)MS104_INTMASK2, mask | MS104_INTMASK2_INT8);
//	chg_ipm(ipm)
}

/*
 *  ed_bus_init -- åȰ¸ΥХν
 */

void
ed_bus_init (void)
{

}

/*
 *  ed_inter_init -- åȰ¸γߤν
 */

void
ed_inter_init (void)
{
//	UB mask;

//	mask = sil_reb_mem((VP)MS104_INTMASK2);
//	sil_wrb_mem((VP)MS104_INTMASK2, mask | MS104_INTMASK2_INT8);
}

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */

#endif	/* of #if defined(SUPPORT_ETHER) */
